;;; wege_Erarbeitung.scm
;;; stellt die Funktionen fuer die Verwaltung der Wege bereit

(load "gallenbacher-graph-kanten.scm")
; Verwendet wird davon die Kantenliste *kanten*
; und die Zugriffsfunktion (nachfolge-kanten <aktuelle-stadt> <kanten>)

; Wege sind Listen aus der Laenge und den besuchten Knoten (rueckwaerts)
; Muster: (60 X B I)

;;; ===== alle-nachfolge-wege =====
; gibt zum aktuellen Weg alle Wege zurueck, die sich aus den
; Nachfolgekanten ergeben.
(define
  (alle-nachfolge-wege weg kanten)
  (define
    (alle-intern die-nachfolger neue-wege)
    'undefiniert
;    (cond ; Rekursion ueber Liste, daher:
;      ((null? ...) ...)
;      ((...) ; nicht zurueck!
;       (...))
;      (else
;       ...)
    )
(alle-intern
 (nachfolge-kanten
  (second weg) ; der aktuelle Knoten steht nach der Laenge im weg
  kanten)
 '()))


;;; ===== Hilfsfunktion neuer-weg =====
; Gibt zu einem Weg und zu einer Kante den verlaengerten Weg zurueck.
(define
  (neuer-weg weg kante)
  'undefiniert
;  (cons
;   (...) ; neue Weglaenge
;   (...) ; Zielort der Kante vorn einbauen
;    )
  )
;Tests:
 (neuer-weg '(34 B I) '(B X 26))
; -> '(60 X B I)

;;; ===== alle-nachfolge-wege =====
; Tests:
 (alle-nachfolge-wege '(22 N A) *kanten*)
; -> '((52 Z N A) (51 X N A) (42 D N A))
